// Code generated by go-bindata. DO NOT EDIT.
// sources:
// db/migrations/000001_create_department_table.down.sql
// db/migrations/000001_create_department_table.up.sql
// db/migrations/000002_create_studentRecord_table.down.sql
// db/migrations/000002_create_studentRecord_table.up.sql
// db/migrations/000003_create_staff_table.down.sql
// db/migrations/000003_create_staff_table.up.sql
// db/migrations/000004_create_attendance_table.down.sql
// db/migrations/000004_create_attendance_table.up.sql
// db/migrations/000005_rename_studentrecord_table.down.sql
// db/migrations/000005_rename_studentrecord_table.up.sql
// db/migrations/000006_add_login_status_column.down.sql
// db/migrations/000006_add_login_status_column.up.sql

package migrations


import (
	"bytes"
	"compress/gzip"
	"fmt"
	"io"
	"io/ioutil"
	"os"
	"path/filepath"
	"strings"
	"time"
)

func bindataRead(data []byte, name string) ([]byte, error) {
	gz, err := gzip.NewReader(bytes.NewBuffer(data))
	if err != nil {
		return nil, fmt.Errorf("Read %q: %v", name, err)
	}

	var buf bytes.Buffer
	_, err = io.Copy(&buf, gz)
	clErr := gz.Close()

	if err != nil {
		return nil, fmt.Errorf("Read %q: %v", name, err)
	}
	if clErr != nil {
		return nil, err
	}

	return buf.Bytes(), nil
}


type asset struct {
	bytes []byte
	info  fileInfoEx
}

type fileInfoEx interface {
	os.FileInfo
	MD5Checksum() string
}

type bindataFileInfo struct {
	name        string
	size        int64
	mode        os.FileMode
	modTime     time.Time
	md5checksum string
}

func (fi bindataFileInfo) Name() string {
	return fi.name
}
func (fi bindataFileInfo) Size() int64 {
	return fi.size
}
func (fi bindataFileInfo) Mode() os.FileMode {
	return fi.mode
}
func (fi bindataFileInfo) ModTime() time.Time {
	return fi.modTime
}
func (fi bindataFileInfo) MD5Checksum() string {
	return fi.md5checksum
}
func (fi bindataFileInfo) IsDir() bool {
	return false
}
func (fi bindataFileInfo) Sys() interface{} {
	return nil
}

var _bindata000001createdepartmenttableDownSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x09\xf2\x0f\x50\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\x70\x8d\xf0\x0c\x0e\x09\x56\x48\x49\x2d\x48\x2c\x2a\xc9\x4d\xcd\x2b\x29\xb6\x06\x04\x00\x00\xff\xff\x01\x7b\x09\x27\x21\x00\x00\x00")

func bindata000001createdepartmenttableDownSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000001createdepartmenttableDownSql,
		"000001_create_department_table.down.sql",
	)
}



func bindata000001createdepartmenttableDownSql() (*asset, error) {
	bytes, err := bindata000001createdepartmenttableDownSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000001_create_department_table.down.sql",
		size: 33,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000001createdepartmenttableUpSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x0e\x72\x75\x0c\x71\x55\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\xf0\xf3\x0f\x51\x70\x8d\xf0\x0c\x0e\x09\x56\x48\x49\x2d\x48\x2c\x2a\xc9\x4d\xcd\x2b\x29\x56\xd0\xe0\x52\x50\x50\x50\xc8\x4c\x51\x48\xca\x4c\xcf\xcc\x2b\x01\x2b\xf3\x0b\xf5\xf1\xd1\x01\x8b\xe7\x25\xe6\xa6\x2a\x94\xa4\x56\x94\x70\x69\x5a\x03\x02\x00\x00\xff\xff\x09\x41\xa3\xb6\x51\x00\x00\x00")

func bindata000001createdepartmenttableUpSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000001createdepartmenttableUpSql,
		"000001_create_department_table.up.sql",
	)
}



func bindata000001createdepartmenttableUpSql() (*asset, error) {
	bytes, err := bindata000001createdepartmenttableUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000001_create_department_table.up.sql",
		size: 81,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000002createstudentRecordtableDownSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x09\xf2\x0f\x50\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\x70\x8d\xf0\x0c\x0e\x09\x56\x28\x2e\x29\x4d\x49\xcd\x2b\x09\x4a\x4d\xce\x2f\x4a\x29\xb6\x06\x04\x00\x00\xff\xff\xf0\xe7\xf3\x77\x24\x00\x00\x00")

func bindata000002createstudentRecordtableDownSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000002createstudentRecordtableDownSql,
		"000002_create_studentRecord_table.down.sql",
	)
}



func bindata000002createstudentRecordtableDownSql() (*asset, error) {
	bytes, err := bindata000002createstudentRecordtableDownSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000002_create_studentRecord_table.down.sql",
		size: 36,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000002createstudentRecordtableUpSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x0e\x72\x75\x0c\x71\x55\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\xf0\xf3\x0f\x51\x70\x8d\xf0\x0c\x0e\x09\x56\x28\x2e\x29\x4d\x49\xcd\x2b\x09\x4a\x4d\xce\x2f\x4a\x29\x56\xd0\xe0\x52\x50\x50\x50\x28\xca\xcf\xc9\xf1\xcb\x57\x48\xca\x4c\xcf\xcc\x2b\x01\xab\xf6\x0b\xf5\xf1\xd1\x01\xcb\xe5\x25\xe6\xa6\x2a\x94\xa4\x56\x94\x40\xb8\x29\xa9\x05\x25\x9e\x2e\x50\xa5\x5c\x9a\xd6\x80\x00\x00\x00\xff\xff\x7a\x20\x80\x8e\x6b\x00\x00\x00")

func bindata000002createstudentRecordtableUpSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000002createstudentRecordtableUpSql,
		"000002_create_studentRecord_table.up.sql",
	)
}



func bindata000002createstudentRecordtableUpSql() (*asset, error) {
	bytes, err := bindata000002createstudentRecordtableUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000002_create_studentRecord_table.up.sql",
		size: 107,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000003createstafftableDownSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x09\xf2\x0f\x50\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\x70\x8d\xf0\x0c\x0e\x09\x56\x28\x2e\x49\x4c\x4b\x0b\x4a\x4d\xce\x2f\x4a\x29\xb6\x06\x04\x00\x00\xff\xff\x65\xed\x05\xd5\x22\x00\x00\x00")

func bindata000003createstafftableDownSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000003createstafftableDownSql,
		"000003_create_staff_table.down.sql",
	)
}



func bindata000003createstafftableDownSql() (*asset, error) {
	bytes, err := bindata000003createstafftableDownSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000003_create_staff_table.down.sql",
		size: 34,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000003createstafftableUpSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x0e\x72\x75\x0c\x71\x55\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\xf0\xf3\x0f\x51\x70\x8d\xf0\x0c\x0e\x09\x56\x28\x2e\x49\x4c\x4b\x0b\x4a\x4d\xce\x2f\x4a\x29\x56\xd0\xe0\x52\x50\x50\x50\x48\xcd\x2d\xf0\x4c\x51\x48\xca\x4c\xcf\xcc\x2b\x01\x2b\xf5\x0b\xf5\xf1\xd1\x01\x4b\xe5\x25\xe6\xa6\x2a\x94\xa4\x56\x94\x40\xb8\x29\xa9\x05\x25\x9e\x2e\x50\xa5\x5c\x9a\xd6\x80\x00\x00\x00\xff\xff\xf4\xa9\x02\x03\x68\x00\x00\x00")

func bindata000003createstafftableUpSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000003createstafftableUpSql,
		"000003_create_staff_table.up.sql",
	)
}



func bindata000003createstafftableUpSql() (*asset, error) {
	bytes, err := bindata000003createstafftableUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000003_create_staff_table.up.sql",
		size: 104,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000004createattendancetableDownSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x09\xf2\x0f\x50\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\x70\x8d\xf0\x0c\x0e\x09\x56\x48\x2c\x29\x49\xcd\x4b\x49\xcc\x4b\x4e\xb5\x06\x04\x00\x00\xff\xff\xce\x25\x92\xf6\x20\x00\x00\x00")

func bindata000004createattendancetableDownSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000004createattendancetableDownSql,
		"000004_create_attendance_table.down.sql",
	)
}



func bindata000004createattendancetableDownSql() (*asset, error) {
	bytes, err := bindata000004createattendancetableDownSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000004_create_attendance_table.down.sql",
		size: 32,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000004createattendancetableUpSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\x0e\x72\x75\x0c\x71\x55\x08\x71\x74\xf2\x71\x55\xf0\x74\x53\xf0\xf3\x0f\x51\x70\x8d\xf0\x0c\x0e\x09\x56\x48\x2c\x29\x49\xcd\x4b\x49\xcc\x4b\x4e\x55\xd0\xe0\x52\x50\x50\x50\x28\xca\xcf\xc9\xc9\xcb\x57\x48\xca\x4c\xcf\xcc\x2b\x01\xab\xf4\x0b\xf5\xf1\xd1\x01\xcb\xe5\xe4\xa7\x67\xe6\x29\x84\x78\xfa\xba\x06\x87\x38\xfa\x06\xc0\x05\xf3\x4b\x4b\x10\xa2\x5c\x9a\xd6\x80\x00\x00\x00\xff\xff\x60\xed\xa4\x6b\x70\x00\x00\x00")

func bindata000004createattendancetableUpSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000004createattendancetableUpSql,
		"000004_create_attendance_table.up.sql",
	)
}



func bindata000004createattendancetableUpSql() (*asset, error) {
	bytes, err := bindata000004createattendancetableUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000004_create_attendance_table.up.sql",
		size: 112,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000005renamestudentrecordtableDownSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\xf4\x09\x71\x0d\x52\x08\x71\x74\xf2\x71\x55\x28\x2e\x29\x4d\x49\xcd\x2b\x51\x08\x72\xf5\x73\xf4\x75\x55\x08\xf1\x87\x89\x14\xa5\x26\xe7\x17\xa5\x14\x5b\x03\x02\x00\x00\xff\xff\x13\x67\x12\x82\x2d\x00\x00\x00")

func bindata000005renamestudentrecordtableDownSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000005renamestudentrecordtableDownSql,
		"000005_rename_studentrecord_table.down.sql",
	)
}



func bindata000005renamestudentrecordtableDownSql() (*asset, error) {
	bytes, err := bindata000005renamestudentrecordtableDownSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000005_rename_studentrecord_table.down.sql",
		size: 45,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000005renamestudentrecordtableUpSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\xf4\x09\x71\x0d\x52\x08\x71\x74\xf2\x71\x55\x28\x2e\x29\x4d\x49\xcd\x2b\x29\x4a\x4d\xce\x2f\x4a\x29\x56\x08\x72\xf5\x73\xf4\x75\x55\x08\xf1\x87\x49\x58\x73\x01\x02\x00\x00\xff\xff\x77\xde\x16\x19\x2e\x00\x00\x00")

func bindata000005renamestudentrecordtableUpSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000005renamestudentrecordtableUpSql,
		"000005_rename_studentrecord_table.up.sql",
	)
}



func bindata000005renamestudentrecordtableUpSql() (*asset, error) {
	bytes, err := bindata000005renamestudentrecordtableUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000005_rename_studentrecord_table.up.sql",
		size: 46,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000006addloginstatuscolumnDownSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\xf4\x09\x71\x0d\x52\x08\x71\x74\xf2\x71\x55\x28\x2e\x29\x4d\x49\xcd\x2b\x51\x70\x09\xf2\x0f\x50\x70\xf6\xf7\x09\xf5\xf5\x53\xc8\xc9\x4f\xcf\xcc\x2b\x2e\x49\x2c\x29\x2d\xb6\x06\x04\x00\x00\xff\xff\xa0\x3b\x24\x27\x2c\x00\x00\x00")

func bindata000006addloginstatuscolumnDownSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000006addloginstatuscolumnDownSql,
		"000006_add_login_status_column.down.sql",
	)
}



func bindata000006addloginstatuscolumnDownSql() (*asset, error) {
	bytes, err := bindata000006addloginstatuscolumnDownSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000006_add_login_status_column.down.sql",
		size: 44,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}

var _bindata000006addloginstatuscolumnUpSql = []byte("\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff\x72\xf4\x09\x71\x0d\x52\x08\x71\x74\xf2\x71\x55\x28\x2e\x29\x4d\x49\xcd\x2b\x51\x70\x74\x71\x51\x70\xf6\xf7\x09\xf5\xf5\x53\xc8\xc9\x4f\xcf\xcc\x0b\x2e\x49\x2c\x29\x2d\x56\x70\xf2\xf7\xf7\x51\x70\x71\x75\x73\x0c\xf5\x09\x51\x48\x4b\xcc\x29\x4e\xb5\xe6\x02\x04\x00\x00\xff\xff\xa1\xc8\x8d\x70\x3f\x00\x00\x00")

func bindata000006addloginstatuscolumnUpSqlBytes() ([]byte, error) {
	return bindataRead(
		_bindata000006addloginstatuscolumnUpSql,
		"000006_add_login_status_column.up.sql",
	)
}



func bindata000006addloginstatuscolumnUpSql() (*asset, error) {
	bytes, err := bindata000006addloginstatuscolumnUpSqlBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{
		name: "000006_add_login_status_column.up.sql",
		size: 63,
		md5checksum: "",
		mode: os.FileMode(420),
		modTime: time.Unix(1582689576, 0),
	}

	a := &asset{bytes: bytes, info: info}

	return a, nil
}


//
// Asset loads and returns the asset for the given name.
// It returns an error if the asset could not be found or
// could not be loaded.
//
func Asset(name string) ([]byte, error) {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	if f, ok := _bindata[cannonicalName]; ok {
		a, err := f()
		if err != nil {
			return nil, fmt.Errorf("Asset %s can't read by error: %v", name, err)
		}
		return a.bytes, nil
	}
	return nil, &os.PathError{Op: "open", Path: name, Err: os.ErrNotExist}
}

//
// MustAsset is like Asset but panics when Asset would return an error.
// It simplifies safe initialization of global variables.
// nolint: deadcode
//
func MustAsset(name string) []byte {
	a, err := Asset(name)
	if err != nil {
		panic("asset: Asset(" + name + "): " + err.Error())
	}

	return a
}

//
// AssetInfo loads and returns the asset info for the given name.
// It returns an error if the asset could not be found or could not be loaded.
//
func AssetInfo(name string) (os.FileInfo, error) {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	if f, ok := _bindata[cannonicalName]; ok {
		a, err := f()
		if err != nil {
			return nil, fmt.Errorf("AssetInfo %s can't read by error: %v", name, err)
		}
		return a.info, nil
	}
	return nil, &os.PathError{Op: "open", Path: name, Err: os.ErrNotExist}
}

//
// AssetNames returns the names of the assets.
// nolint: deadcode
//
func AssetNames() []string {
	names := make([]string, 0, len(_bindata))
	for name := range _bindata {
		names = append(names, name)
	}
	return names
}

//
// _bindata is a table, holding each asset generator, mapped to its name.
//
var _bindata = map[string]func() (*asset, error){
	"000001_create_department_table.down.sql":    bindata000001createdepartmenttableDownSql,
	"000001_create_department_table.up.sql":      bindata000001createdepartmenttableUpSql,
	"000002_create_studentRecord_table.down.sql": bindata000002createstudentRecordtableDownSql,
	"000002_create_studentRecord_table.up.sql":   bindata000002createstudentRecordtableUpSql,
	"000003_create_staff_table.down.sql":         bindata000003createstafftableDownSql,
	"000003_create_staff_table.up.sql":           bindata000003createstafftableUpSql,
	"000004_create_attendance_table.down.sql":    bindata000004createattendancetableDownSql,
	"000004_create_attendance_table.up.sql":      bindata000004createattendancetableUpSql,
	"000005_rename_studentrecord_table.down.sql": bindata000005renamestudentrecordtableDownSql,
	"000005_rename_studentrecord_table.up.sql":   bindata000005renamestudentrecordtableUpSql,
	"000006_add_login_status_column.down.sql":    bindata000006addloginstatuscolumnDownSql,
	"000006_add_login_status_column.up.sql":      bindata000006addloginstatuscolumnUpSql,
}

//
// AssetDir returns the file names below a certain
// directory embedded in the file by go-bindata.
// For example if you run go-bindata on data/... and data contains the
// following hierarchy:
//     data/
//       foo.txt
//       img/
//         a.png
//         b.png
// then AssetDir("data") would return []string{"foo.txt", "img"}
// AssetDir("data/img") would return []string{"a.png", "b.png"}
// AssetDir("foo.txt") and AssetDir("notexist") would return an error
// AssetDir("") will return []string{"data"}.
//
func AssetDir(name string) ([]string, error) {
	node := _bintree
	if len(name) != 0 {
		cannonicalName := strings.Replace(name, "\\", "/", -1)
		pathList := strings.Split(cannonicalName, "/")
		for _, p := range pathList {
			node = node.Children[p]
			if node == nil {
				return nil, &os.PathError{
					Op: "open",
					Path: name,
					Err: os.ErrNotExist,
				}
			}
		}
	}
	if node.Func != nil {
		return nil, &os.PathError{
			Op: "open",
			Path: name,
			Err: os.ErrNotExist,
		}
	}
	rv := make([]string, 0, len(node.Children))
	for childName := range node.Children {
		rv = append(rv, childName)
	}
	return rv, nil
}


type bintree struct {
	Func     func() (*asset, error)
	Children map[string]*bintree
}

var _bintree = &bintree{Func: nil, Children: map[string]*bintree{
	"000001_create_department_table.down.sql": {Func: bindata000001createdepartmenttableDownSql, Children: map[string]*bintree{}},
	"000001_create_department_table.up.sql": {Func: bindata000001createdepartmenttableUpSql, Children: map[string]*bintree{}},
	"000002_create_studentRecord_table.down.sql": {Func: bindata000002createstudentRecordtableDownSql, Children: map[string]*bintree{}},
	"000002_create_studentRecord_table.up.sql": {Func: bindata000002createstudentRecordtableUpSql, Children: map[string]*bintree{}},
	"000003_create_staff_table.down.sql": {Func: bindata000003createstafftableDownSql, Children: map[string]*bintree{}},
	"000003_create_staff_table.up.sql": {Func: bindata000003createstafftableUpSql, Children: map[string]*bintree{}},
	"000004_create_attendance_table.down.sql": {Func: bindata000004createattendancetableDownSql, Children: map[string]*bintree{}},
	"000004_create_attendance_table.up.sql": {Func: bindata000004createattendancetableUpSql, Children: map[string]*bintree{}},
	"000005_rename_studentrecord_table.down.sql": {Func: bindata000005renamestudentrecordtableDownSql, Children: map[string]*bintree{}},
	"000005_rename_studentrecord_table.up.sql": {Func: bindata000005renamestudentrecordtableUpSql, Children: map[string]*bintree{}},
	"000006_add_login_status_column.down.sql": {Func: bindata000006addloginstatuscolumnDownSql, Children: map[string]*bintree{}},
	"000006_add_login_status_column.up.sql": {Func: bindata000006addloginstatuscolumnUpSql, Children: map[string]*bintree{}},
}}

// RestoreAsset restores an asset under the given directory
func RestoreAsset(dir, name string) error {
	data, err := Asset(name)
	if err != nil {
		return err
	}
	info, err := AssetInfo(name)
	if err != nil {
		return err
	}
	err = os.MkdirAll(_filePath(dir, filepath.Dir(name)), os.FileMode(0755))
	if err != nil {
		return err
	}
	err = ioutil.WriteFile(_filePath(dir, name), data, info.Mode())
	if err != nil {
		return err
	}
	return os.Chtimes(_filePath(dir, name), info.ModTime(), info.ModTime())
}

// RestoreAssets restores an asset under the given directory recursively
func RestoreAssets(dir, name string) error {
	children, err := AssetDir(name)
	// File
	if err != nil {
		return RestoreAsset(dir, name)
	}
	// Dir
	for _, child := range children {
		err = RestoreAssets(dir, filepath.Join(name, child))
		if err != nil {
			return err
		}
	}
	return nil
}

func _filePath(dir, name string) string {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	return filepath.Join(append([]string{dir}, strings.Split(cannonicalName, "/")...)...)
}
